// E3D fanfanfan duct
// ::: Fan duct :::
// CC BY 3.0 Tom Øyvind Hogstad <tom.oyvind.hogstad@gmail.com> Mars 2014

use <utility.scad>
include <configuration.scad>

fan_duct();

module fan_duct() {
	block_h = _floor + heat_sink_large_r*2+2;
	
	difference() {
		union()  {
			difference() {
				hull()
					for(x=[-1,1], y=[-1,1]) 
						translate([x*fan40_hole_dx/2,y*fan40_hole_dx/2,0]) cylinder(r1=poly_r(4, 32), r2=0,h=block_h-2, $fn=32);
				translate([-20, -20, _floor + heat_sink_large_r+duct_addon_h]) cube(40);
			}
			if (fan30)
			translateZ(4+screw_r) {
				fan30_holder();	
				mirror() fan30_holder();	
			}
		}
		translateZ(-1) cylinder(r1=fan40_hole_r,r2=0, h=fan40_hole_r, $fn=64);

		#translate([0,-20,poly_r(heat_sink_large_r, $fn=64)+_floor]) rotateX(-90) cylinder(r=poly_r(heat_sink_large_r-0.2, $fn=64), h=heat_sink_large_h+4.5, $fn=64);
		translate([0, 20 - (40-heat_sink_large_h)-1 ,poly_r(heat_sink_large_r, $fn=64)+_floor]) rotateX(-90) cylinder(r=poly_r(heat_sink_small_r-0.2, $fn=32), h=20, $fn=32);
		translate([0, 20 - (40-heat_sink_large_h)-1 ,poly_r(heat_sink_large_r, $fn=64)+_floor+7]) rotateX(-90) cylinder(r=poly_r(heat_sink_small_r, $fn=32), h=20, $fn=32);

		for(x=[-1,1], y=[-1,1]) {
			translate([x*fan40_hole_dx/2,y*fan40_hole_dx/2,-1]) cylinder(r=screw_r,h=_floor + heat_sink_large_r+duct_addon_h-4, $fn=8);
			translate([x*fan40_hole_dx/2,y*fan40_hole_dx/2,-1]) cylinder(r1=screw_r+1,, r2=screw_r, h=4, $fn=8);
		}

	}
}

module fan30_holder() {
	translate([fan40_hole_dx/2+4,-fan40_hole_dx/2-4,0]) rotate(-(90-fan30_angle)) 
		difference() {
			cube([4+4+screw_r*2+4, 4,4+screw_r*2+4], center=true);	
			translate([2, 0,0]) rotateX(90) rotate(180/8) cylinder(r=screw_r, h=20, $fn=8, center=true);
		}
}
